{------------------------------------------------------------------}
{  SimMaal :   1.0                                                 }
{  Simmulering hastighedsmling med optiske skiver                 }
{                                                                  }
{               ds(t)            v: hastiged                       }
{      v(t) =  ------           ds: ndring i sted                 }
{                dt             dt: ndring i tid                  }
{                                                                  }
{  Der sammenlignes mellem 2 metoder                               }
{                                                                  }
{  1.  Tid for et skift optlles og danner basis                   }
{            princip: ndring i sted fast, tid variabel            }
{                                                                  }
{  2.  Der optlles skift over en fast tid ( <= skift ved max.)    }
{            princip: ndring i sted variabel, tid konstant        }
{      Der arbejdes med "glidende vindue".                         }
{                                                                  }
{  Programmr:  Bjrk Boye Busch                                   }
{  Dato:        14. November  1994                                 }
{  CopyRight -  M ikke kopieres uden individuel aftale            }
{------------------------------------------------------------------}

{x$A+}  {Word allign}
{x$G+}  {80286 instruktionsst }
{x$R+}  {Range }
{x$S+}  {Stack }
{x$N+}  {8087}
{x$D+}  {Debug info}

uses
  Dos, Crt, Graph, RegulOBJ, GrafSys1;
Var
   GTabX:  GrafTabKlasse;
   GTab0:  GrafTabKlasse;
   GTab1:  GrafTabKlasse;
   GTab2:  GrafTabKlasse;
   GTabT:  GrafTabKlasse;
   TTab:   Array[0..640] of Real;
   STab:   Array[0..640] of Real;
   Tix: Integer;

Const
   test0:Boolean=False;
   test1:Boolean=False;
   test2:Boolean=False;

   FixHastTrin:Integer = 50; { antal trin med samme hastighed }
   AOplos:Integer   = 32;    { anvendt oplsning}
   TA:Real          = 1;     { Samplingstid anvendelse = 1 enhed  }
   T2:Real          = 0.01;  { Samplingstid mleustyr 2  }
   Oplos1:Real      = 0.0002;{ TIDS oplsning i mling 1 }
   Oplos2:Integer   = 32;    { BIT oplsning i mling 2   1/2/4/8...256 }

   TopTrin:Word     = 10;

   Skriv    = False;
   AutoProcesK: Boolean = True;
   AutoEnh1:    Boolean = True;
   AutoEnh2:    Boolean = True;

   ProcesK: Real = 0.2;
   Senh1: Real = 0.1;    { oplsningsenhed Mling 1 }
   Senh2: Real = 0.32;   { oplsningsenhed Mling 2 }
   M        = 1.0;       { fast procesinput }
   MaxSampl: Integer = 100;
   MaxHast : Real = 31;
   StopHast: Real = 22;

Var
   P1,P2: ElmKlasseIntegral1;

   AbsS: Real;    { Absolutte faktiske position }
   AbsT: Real;    { Absolutte tidpunkt      }

   n,wn:         Integer;  { samplingsnr }
   Tbeg, Tend:   Real;     { start/slut tid  for opto-skift }
   Mbeg, Mend:   Real;     { start/slut tid  for mlesampling }
   Sbeg, Send:   Real;     { start/slut pos. for opto-skift }
   DT,WDT:       Real;     { ndring i tid  }
   DS:           Real;     { ndring i pos. }
   SkiftTab:     Array[0..4095] of integer;
   SkiftIx:      Integer;
   Skift:        Integer;
   Foto,OldFoto,NextFoto: Integer;
   Hast,OldHast,NextHast: Real;

Procedure Maal0;     { reference }
Var
   Tp: Real;
   Tx: Real;
begin
   GTabx.GrafTabInit(1);       GTab0.PutPre(0);
   GTab0.GrafTabInit(1);       GTab0.PutPre(0);
   AbsS := 0;
   AbsT := 0;
   If AutoProcesK then ProcesK := ((AOplos/TopTrin)/TA);
   MaxSampl := ROUND(TopTrin*1.5);

   Tx := TA*FixHastTrin;
   P1.Init(ProcesK, Tx);
   P2.Init(0, TA);
   n := 0;
   Hast := 0;
   Repeat
      GTabX.PutY(MaxHast);
      GTab0.PutY(hast);
      TTab[n] := AbsT;
      STab[n] := AbsS;
      if (n MOD FixHastTrin) = 0 then Hast := P1.Out(M) + P2.Out(M);
if test0 then if n < 10 then hast := 10.3 else hast := 0;
if test2 then if n < 10 then hast := 10 else hast := 0;
      n := n + 1;
      if n = TopTrin then P2.Init(-2*ProcesK, Tx);
      AbsS := AbsS + Hast*TA;
      AbsT := AbsT + TA;
   Until (n >= MaxSampl);
   TTab[n] := 9999999999999.0;
   STab[n] := 9999999999999.0; {STab[n-1];}
end;

Procedure Maal1;
begin
   GTab1.GrafTabInit(1);       GTab1.PutPre(0);

   n       := 0;
   wn      := 0;
   Tend    := TTab[wn];
   Send    := STab[wn];
   NextHast:= 0;
   Repeat
      Hast := NextHast;
      Tbeg := Tend;
      Sbeg := Send;
      Send := Sbeg + Senh1;
      While (STab[wn+1] <= Send) do wn := wn +1;  { find skift-sampling }
      if STab[wn+1] = Send then
         Tend := TTab[wn+1]       { skift ved sampling start }
      else
         Tend := TTab[wn] +       { interpoler resten }
                 ( (TTab[wn+1]-TTab[wn])*(Send-STab[wn]) /
                       (STab[wn+1]-STab[wn])                );

      DT := Tend - Tbeg;

      DT := INT(DT/Oplos1)*Oplos1;

      if DT > 0 then NextHast := Trunc((Senh1/DT)+0.00000000001)
      else           NextHast := 999999;
if test1 then begin
WriteLN('Skifte: ',n,'  DT:',DT,' Senh1:',Senh1{:8:5},' Send:',Send:8:5,' h:',NextHast);
READLN;
end;
      if NextHast>MaxHast then NextHast := MaxHast;
      if DT = 9999999999999.0 then NextHast := 0;   { time out }
      While (TTab[n] <= Tend) AND (n <= MaxSampl) do begin
         GTab1.PutY(Hast);
         n := n + 1;
      end;
if test1 then GTabT.PutY(NextHast);
   Until (n >= MaxSampl);
end;

Procedure Maal2;
begin
   GTab2.GrafTabInit(1);       GTab2.PutPre(0);
   FillChar(SkiftTab,SizeOf(SkiftTab),#0);
   SkiftIx := 0;

   n       := 0;
   wn      := 0;
   Tend    := TTab[wn];
   Send    := STab[wn];
   NextHast:= 0;
   Foto    := 0;
   NextFoto:= 0;
   OldFoto := 0;
   AbsT    := Tend;
   Mbeg    := Tend;
   Mend    := Mbeg + T2;
   DS      := 0;
   Skift   := 0;
   Repeat
      Hast    := NextHast;
      Tbeg    := Tend;
      Sbeg    := Send;
      Send    := Sbeg + Senh2;
      While (STab[wn+1] <= Send) do wn := wn +1;  { find skift-sampling }
      if STab[wn+1] = Send then
         Tend := TTab[wn+1]       { skift ved sampling start }
      else
         Tend := TTab[wn] +       { interpoler resten }
                 ( (TTab[wn+1]-TTab[wn])*(Send-STab[wn]) /
                       (STab[wn+1]-STab[wn])                );
      NextFoto := NextFoto XOR 1;   { skift }
if test2 then WriteLN('Skifte: ',n,' Tend:',Tend:8:5,' Send:',Send:8:5,' Foto:',Foto);
      While (Mend <= Tend) AND (n <= MaxSampl) do begin   { mling frem }
         Hast    := NextHast;                             { til skift   }
         SkiftTab[SkiftIx] := Skift;
         SkiftIx := (SkiftIx+1) AND (Oplos2-1);
         Ds := Ds + Skift - SkiftTab[SkiftIx];
         Hast := Round((Ds*(MaxHast+1))/Oplos2);
         if Hast>MaxHast then Hast := MaxHast;
if test2 then WriteLN('Sampl Mbeg:',Mbeg:8:5,' Tend:',Tend:8:5,' Mend:',Mend:8:5,'  DS:',DS:8:5,' Skift:',Skift);
         Mbeg := Mend;
         Mend := Mend + T2;
         Skift := 0;
         While (TTab[n] <= Mend) AND (n <= MaxSampl) do begin  {sampling}
if test2 then WriteLN('N:',n,' Hast:',Hast:8:5,' DS:',DS:8:5); {til mling}
            GTab2.PutY(Hast);
            n := n + 1;
         end;
      end;
if test2 then WriteLN('Old:',OldFoto,' Akt:',Foto,' New:',NextFoto);
if test2 then READLN;
      Skift := Foto XOR NextFoto;
      OldFoto := Foto;
      Foto    := NextFoto;
      {Skift := 1;}
if test2 then GTabT.PutY(HAST);
   Until (n >= MaxSampl);

end;

Procedure Grafik;
Const
   ColorX = Red; Color0 = Green; Color1=Yellow; Color2=Cyan; ColorT=Blue;
Var
   S: String;
   MaxY: Real;
Begin
   GTabx.SetGrafColor(ColorX); GTabx.SetGrafKant(0);
   GTab0.SetGrafColor(Color0); GTab0.SetGrafKant(1);
   GTab1.SetGrafColor(Color1); GTab1.SetGrafKant(1);
   GTab2.SetGrafColor(Color2); GTab2.SetGrafKant(1);
   GTabT.SetGrafColor(ColorT); GTabT.SetGrafKant(1);

   GrafSys.GrafSetHeader('Hastighedsmling med optiske skiver','(C) Bjrk Busch');
   GrafSys.GrafSetSysColor(Blue,White,Black,Black,White);
   GrafSys.GrafSetXNavn('T');
   GrafSys.GrafOpen;

   if StopHast>MaxHast then MaxY := StopHast else MaxY := MaxHast;
   MaxY := MaxY*1.2;
   GrafSys.GrafSetWorldXSize(0, MaxSampl);
   GrafSys.GrafSetWorldYSize(0, MaxY);
   GrafSys.GrafKoordinat(0,MaxSampl, 1);

   GTabx.SkrivGrafTab;
   GTab0.SkrivGrafTab;
   GTab1.SkrivGrafTab;
   GTab2.SkrivGrafTab;

   SetFillStyle(SolidFill, Black);
   BAR(50, 15, 50+25*9+10,15+4*11+10);
   SetColor(ColorX); OutTextXY(50+5, 20+00, 'Max mleniveau');
   SetColor(Color0); OutTextXY(50+5, 20+11, 'Faktiske niveau');
   SetColor(Color2); OutTextXY(50+5, 20+22, 'Mlt niveau type2:  fast tid  / variabel sted, integration');
   SetColor(Color1); OutTextXY(50+5, 20+33, 'Mlt niveau type1:  fast sted / variabel tid');

   SetFillStyle(SolidFill, Black);
   BAR(250, 290, 300+25*9+10,300+4*14+10);
   SetColor(White);
                          OutTextXY(250+5, 300+000, 'Anvendelse:');
   Str(ProcesK:9:6,S);    OutTextXY(250+5, 300+011, '   Proceskonstant :'+S);
   Str(TA:9:6,S);         OutTextXY(250+5, 300+022, '   Samplingstid   :'+S);
   Str(AOplos:3,S);       OutTextXY(250+5, 300+033, '   Oplsning      :'+S);

   SetColor(Color2);
                          OutTextXY(250+5, 300+060, 'Mleudstyr 2:');
   Str(SEnh2:9:6,S);      OutTextXY(250+5, 300+071, '   Mleenhed      :'+S);
   Str(T2:9:6,S);         OutTextXY(250+5, 300+082, '   Samplingstid   :'+S);
   Str(Oplos2:3,S);       OutTextXY(250+5, 300+093, '   Oplsning      :'+S);

   SetColor(Color1);
                          OutTextXY(250+5, 300+110, 'Mleudstyr 1:');
   Str(SEnh1:9:6,S);      OutTextXY(250+5, 300+121, '   Mleenhed      :'+S);
   Str(Oplos1:9:6,S);     OutTextXY(250+5, 300+132, '   Tidsoplsning  :'+S);

end;

Procedure LaesSysData;
Var
   Opl1: Integer;
   stal:String[20];
   numerr:Integer;
   wtal:word;
   rtal:Real;
begin
   ClrScr;
   WriteLN(' Simulering af mlemetoder                                (C) Bjrk Busch 1994');
   WriteLN(' Hastighedmling med optiske skiver                                           ');
   WriteLN;WriteLN;WriteLN;
{
   Write('Test ?'); ReadLN(Stal);
   if Stal = '0' then Test0 := True else Test0 := False;
   if Stal = '1' then Test1 := True else Test1 := False;
   if Stal = '2' then Test2 := True else Test2 := False;
}
   WriteLN('Tast 0 for stop');
   WriteLN;WriteLN;

   Write('Indtast anvendt oplsning (2-potens)          ',
          AOplos:10, ' : ');
   ReadLN(Stal); Val(Stal,Wtal,numerr);
   if (Stal>' ') AND (numerr=0) then AOplos:= Wtal;
   if AOplos < 2 then HALT(1);

   Write('Indtast  antal samplinger                     ',
          TopTrin*1.5:10:6, ' : ');
   ReadLN(Stal); Val(Stal,Wtal,numerr);
   if (Stal>' ') AND (numerr=0) then TopTrin := Round(Wtal/1.5);
   if TopTrin < 5 then HALT(1);
   WriteLN;

   Write('Indtast  antal trin mellem niveauskift        ',
         FixHastTrin:10, ' : ');
   ReadLN(Stal); Val(Stal,Wtal,numerr);
   if (Stal>' ') AND (numerr=0) then FixHastTrin:= Wtal;
   if FixHastTrin < 1 then HALT(1);
   if FixHastTrin > TopTrin DIV 2 then FixHastTrin := TopTrin DIV 2;
   WriteLN;

   Write('Indtast oplsning p mletype 2 (2-potens)    ',
         Oplos2:10, ' : ');
   ReadLN(Stal); Val(Stal,Wtal,numerr);
   if (Stal>' ') AND (numerr=0) then Oplos2:= Wtal;
   if Oplos2 < 1 then HALT(1);

   Write('Indtast mlesamplingstid p mletype 2        ',
         T2:10:6, ' : ');
   ReadLN(Stal); Val(Stal,Rtal,numerr);
   if (Stal>' ') AND (numerr=0) then T2:= Rtal;
   if T2 < 0.000000000000000001 then HALT(1);
   If AutoEnh2 then Senh2 := T2*(MaxHast);
                          { oplsningsenhed Mling 2 }

   Write('Indtast mleenhed p mletype 2               ',
          Senh2:10:6, ' : ');
   ReadLN(Stal); Val(Stal,Rtal,numerr);
   if (Stal>' ') AND (numerr=0) then Senh2:= Rtal;
   if Senh2 < 0.000000000000000001 then HALT(1);
   WriteLN;

   Write('Indtast tidsoplsning p mletype 1           ',
         Oplos1:10:6, ' : ');
   ReadLN(Stal); Val(Stal,Rtal,numerr);
   if (Stal>' ') AND (numerr=0) then Oplos1:= Rtal;
   if Oplos1 < 0.000000000000000001 then HALT(1);

   Write('Indtast mleenhed p mletype 1               ',
          Senh2:10:5, ' : ');
   ReadLN(Stal); Val(Stal,Rtal,numerr);
   if (Stal>' ') AND (numerr=0) then Senh1:= Rtal
   else If AutoEnh1 then Senh1 := Senh2;      { oplsningsenhed Mling 1 }
   if Senh1 < 0.000000000000000001 then HALT(1);
   WriteLN;WriteLN;

   MaxHast  := AOplos-1;
   StopHast := MaxHast*0.98;


end;


Var
   Tal: Integer;
   Svar: Char;
Begin
   Repeat
      LaesSysData;
      GTabx.GrafTabInit(1);       GTab0.PutPre(0);
      GTab0.GrafTabInit(1);       GTab0.PutPre(0);
      GTab1.GrafTabInit(1);       GTab1.PutPre(0);
      GTab2.GrafTabInit(1);       GTab2.PutPre(0);
      GTabT.GrafTabInit(1);       GTabT.PutPre(0);
      Maal0;
      Maal1;
      Maal2;
      Grafik;
      Repeat until Keypressed;
      Repeat
         Repeat Svar := ReadKey Until NOT KeyPressed;
         Case Svar of
            '0':     GTab0.SkrivGrafTab;
            '1':     GTab1.SkrivGrafTab;
            '2':     GTab2.SkrivGrafTab;
            't','T': GTabT.SkrivGrafTab;
            else;
         end;
      until Svar IN [#3,#27,#13];
      GrafSys.GrafClose;
   until Svar IN [#3,#27];
end.
